# @(#)12  1.4 src/cmdline/staging/scripts/list_federations.py, amws.cmdline, fim611, 060921a 9/18/06 16:18:29
# (C) Copyright International Business Machines Corporation 2005. All rights
# reserved.  U.S. Government Users Restricted Rights -- Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

from com.tivoli.am.fim.middlemanager.ssps import FederationManager
from fim_base import read_properties_file, get_domain_instance
from fed_utils import list_federations, get_federations
from domain_utils import is_domain_present
from com.tivoli.am.fim.logging import FIMLoggerFactory
from com.tivoli.am.fim.logging import FIMLogger
from com.tivoli.am.fim.logging import FIMLevel
from com.tivoli.am.fim.i18n.msgs import CmdLineMessages
from jarray import array
from java.lang import Object
from com.tivoli.am.fim.logging import FIMLoggerConstants

# Set up FIMLogger
component_name = "StagingTools"
script_name = "list_federations.py"
method_name = script_name
class_name = "com.tivoli.am.fim.cmdline." + script_name[0:-3]
FIMLoggerFactory.enableStdout(FIMLevel.ALL)
FIMLoggerFactory.setPreferredFIMLoggerImpl(FIMLoggerConstants.FIMLOGGER_BASE_IMPL)
log = FIMLoggerFactory.getFIMLogger(component_name, class_name, CmdLineMessages.CLASS_NAME)

def usage():
    inserts = array([script_name],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.usage_list_federations, \
        inserts)
    raise SystemExit

if __name__ == 'main':
    
    if len(sys.argv) < 1 or len(sys.argv) > 2:
        usage()

    props_file = sys.argv[0]
    props = read_properties_file(props_file)
    if not is_domain_present(props):
        raise SystemExit
    
    domain = get_domain_instance(props)
    fed_mgr = FederationManager.getInstance(method_name, domain)

    fed_id_map=get_federations(fed_mgr)
    if not fed_id_map.keys(): # no federations in this domain
        inserts = array([props["Domain"]],Object)
        log.logMessage(FIMLevel.INFO, method_name, \
            CmdLineMessages.no_federations_exist_for_this_domain, inserts)
        raise SystemExit

    inserts = array([props["Domain"]],Object)
    log.logMessage(FIMLevel.INFO, method_name, CmdLineMessages.printing_federations, \
        inserts)

    if len(sys.argv) == 2 and sys.argv[1] == "-show_ids":
        list_federations(fed_mgr, 1)
    else:
        list_federations(fed_mgr, 0)
    
    raise SystemExit
                                                                                

